using System;
using System.Collections.Generic;
using System.Text;
using System.Threading;

namespace I2CDotNet
{
    /***************************************************************************************
    * This short program demonstrates how to access a device by using the .Net wrapper for 
    * Compulab's I2C Driver.  This device is an EEPROM on the SB-T35, the EEPROM is connected
    * through I2C3.
    ***************************************************************************************/
    class Program
    {
        //Set values for this sample
        internal const UInt32 DEVICE_ADDRESS = 0x50;  //EEProm I2C address
        internal const UInt32 READ_REGISTER_OFFSET = 0x8;
        internal const UInt32 WRITE_REGISTER_OFFSET = 0xA;
        internal const UInt32 WRITE_BYTE_COUNT = 2;
        internal const UInt32 READ_BYTE_COUNT = 2;
        internal const UInt32 MESSAGE_BUFFER_SIZE = 2;
        internal const byte WRITE_DATA1 = 0x10;
        internal const byte WRITE_DATA2 = 0xAB;
        internal const int I2C_PORT_NUMBER = 3;

        private static I2C_CmT35 hI2C;
        private static UInt32 address, count;
        private static byte[] buffer1 = new byte[MESSAGE_BUFFER_SIZE];
        private static byte[] buffer2 = new byte[MESSAGE_BUFFER_SIZE];
        static void Main(string[] args)
        {
            //Creates an instance of the I2C driver .Net wrapper
            hI2C = new I2C_CmT35(I2C_PORT_NUMBER);

            //Sets  the slave address            
            hI2C.SetSlaveAddress(DEVICE_ADDRESS);

            address = READ_REGISTER_OFFSET;
            count = READ_BYTE_COUNT;

            //Reads data from device
            hI2C.Read(address, buffer1, count);
            System.Console.WriteLine("Read " + count + " bytes from I2C device: " + buffer1[0] + ", " + buffer1[1]);

            //Writes data
            buffer2[0] = WRITE_DATA1;
            buffer2[1] = WRITE_DATA2;
            address = WRITE_REGISTER_OFFSET;
            count = WRITE_BYTE_COUNT;
            hI2C.Write(address, buffer2, count);
            Thread.Sleep(10);
            
            //Verifying data
            buffer2[0] = 0;
            buffer2[1] = 0;
            hI2C.Read(address, buffer2, count);
            System.Console.WriteLine("Read " + count + " bytes from I2C device: " + buffer2[0] + ", " + buffer2[1]);
            Thread.Sleep(10000);
        }
    }
}
